////////////////////////////////////////////////////////////////////////////
//
// mNbN.
// \W[.
//
// Copyright by rubidesu 2018
// http://www.gatelink.co.jp/hw/
//
////////////////////////////////////////////////////////////////////////////

#include <16f87.h>

#fuses INTRC_IO, NOLVP, NOWDT, PUT, NOPROTECT, NOBROWNOUT, NOMCLR, CCPB3
#use delay(clock=8000000)
#use rs232(BAUD=9600, XMIT=PIN_B5, RCV=PIN_B2)

//7ZOLEDڑ|[g.
#BIT LED_A = 6.0	//PORTB bit0.
#BIT LED_B = 6.1	//PORTB bit1.
#BIT LED_C = 6.3	//PORTB bit3.
#BIT LED_D = 6.4	//PORTB bit4.
#BIT LED_E = 6.6	//PORTB bit6.
#BIT LED_F = 6.7	//PORTB bit7.
#BIT LED_G = 5.6	//PORTA bit6.

#BIT DIG_1 = 5.0	//PORTA bit0.
#BIT DIG_2 = 5.1	//PORTA bit1.
#BIT DIG_3 = 5.2	//PORTA bit2.
#BIT DIG_4 = 5.3	//PORTA bit3.
#BIT DIG_5 = 5.4	//PORTA bit4.

//7ZOLED̕\f[^.
#define MAX_PRINT_INDEX		5
BYTE bPrintStr[MAX_PRINT_INDEX] = {0, 0, ':', 0, 0};
BYTE bPrintIndex = 0;

//Mf[^obt@.
#define RCV_MAX		64			//Mobt@TCY.
BYTE rcv_stack[RCV_MAX];		//Mobt@.
BYTE rcv_read = 0;				//Mobt@̃[h|C^.
BYTE rcv_write = 0;				//Mobt@̃Cg|C^.
BYTE rcv_buff;					//Mobt@󂯓npϐ.

#define RCV_DATA_MAX	32		//Mobt@̃TCY.

//^C}1X^[g/Xgbv邽߂̃WX^AhXƃrbg.
#bit  T1Start = 0x10.0
//RyAW[̃WX^AhX.
#byte CCP1CON = 0x17

//ṽR_EtO.
BYTE bColonFlag = 0;
//R_EJE^.
BYTE bColonCnt = 0;

////////////////////////////////////////////////////////////////////////////
// VAM荞.
////////////////////////////////////////////////////////////////////////////
#INT_RDA
void int_rda_isr(void)
{
	rcv_stack[rcv_write] = getc();

	rcv_write++;
	rcv_write = rcv_write % RCV_MAX;
}

////////////////////////////////////////////////////////////////////////////
// VAMf[^̎擾.
////////////////////////////////////////////////////////////////////////////
BYTE getc_buff(void)
{
	if(rcv_read != rcv_write){
		rcv_buff = rcv_stack[rcv_read];
		rcv_read++;
		rcv_read = rcv_read % RCV_MAX;
		return 1;
	}
	else{
		return 0;
	}
}

////////////////////////////////////////////////////////////////////////////
// 7ZOgLED̓_.
////////////////////////////////////////////////////////////////////////////
#INT_RTCC
RTCC_isr()
{
	//LED̎ch~̂߈U\OFF.
	DIG_1 = DIG_2 = DIG_3 = DIG_4 = DIG_5 = 0;

	//f[^o.
	switch(bPrintStr[bPrintIndex]){
	case 0:
		LED_A = 1;
		LED_B = 1;
		LED_C = 1;
		LED_D = 1;
		LED_E = 1;
		LED_F = 1;
		LED_G = 0;
		break;
	case 1:
		LED_A = 0;
		LED_B = 1;
		LED_C = 1;
		LED_D = 0;
		LED_E = 0;
		LED_F = 0;
		LED_G = 0;
		break;
	case 2:
		LED_A = 1;
		LED_B = 1;
		LED_C = 0;
		LED_D = 1;
		LED_E = 1;
		LED_F = 0;
		LED_G = 1;
		break;
	case 3:
		LED_A = 1;
		LED_B = 1;
		LED_C = 1;
		LED_D = 1;
		LED_E = 0;
		LED_F = 0;
		LED_G = 1;
		break;
	case 4:
		LED_A = 0;
		LED_B = 1;
		LED_C = 1;
		LED_D = 0;
		LED_E = 0;
		LED_F = 1;
		LED_G = 1;
		break;
	case 5:
		LED_A = 1;
		LED_B = 0;
		LED_C = 1;
		LED_D = 1;
		LED_E = 0;
		LED_F = 1;
		LED_G = 1;
		break;
	case 6:
		LED_A = 1;
		LED_B = 0;
		LED_C = 1;
		LED_D = 1;
		LED_E = 1;
		LED_F = 1;
		LED_G = 1;
		break;
	case 7:
		LED_A = 1;
		LED_B = 1;
		LED_C = 1;
		LED_D = 0;
		LED_E = 0;
		LED_F = 1;
		LED_G = 0;
		break;
	case 8:
		LED_A = 1;
		LED_B = 1;
		LED_C = 1;
		LED_D = 1;
		LED_E = 1;
		LED_F = 1;
		LED_G = 1;
		break;
	case 9:
		LED_A = 1;
		LED_B = 1;
		LED_C = 1;
		LED_D = 1;
		LED_E = 0;
		LED_F = 1;
		LED_G = 1;
		break;
	case ':':	//R.
		LED_A = bColonFlag;
		LED_B = bColonFlag;
		LED_C = 0;
		LED_D = 0;
		LED_E = 0;
		LED_F = 0;
		LED_G = 0;
		break;
	}

	//̐؂ւ.
	switch(bPrintIndex){
	case 0:
		DIG_1 = 1;
		break;
	case 1:
		DIG_2 = 1;
		break;
	case 2:
		DIG_3 = 1;
		break;
	case 3:
		DIG_4 = 1;
		break;
	case 4:
		DIG_5 = 1;
		break;
	}

	//\i߂.
	bPrintIndex = bPrintIndex + 1;
	bPrintIndex = bPrintIndex % MAX_PRINT_INDEX;
}

////////////////////////////////////////////////////////////////////////////
// R_ŗp
////////////////////////////////////////////////////////////////////////////
#INT_CCP1
void int_ccp1_isr(void)
{
	//100msecƂɊ荞݂.
	if(bColonCnt == 4){	//500msecPʂŃR_ł.
		bColonFlag = !bColonFlag;
		bColonCnt = 0;
	}
	else{
		bColonCnt++;
	}
}

////////////////////////////////////////////////////////////////////////////
// C.
//
// IN:
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
main()
{
	BYTE iIndex = 0;
	BYTE bBuff[RCV_DATA_MAX];

	setup_oscillator(OSC_8MHZ);

	set_tris_a(0b10100000);
	set_tris_b(0b00000100);

	//setup_adc_ports(NO_ANALOGS|VSS_VDD); 
	//setup_adc(ADC_OFF); 
	setup_spi(SPI_SS_DISABLED); 
	setup_comparator(NC_NC_NC_NC); 
	//setup_vref(FALSE); 

	LED_A = LED_B = LED_C = LED_D = LED_E = LED_F = LED_G = 0;
	DIG_1 = DIG_2 = DIG_3 = DIG_4 = DIG_5 = 0;

	//7ZOgLED̃_Ci~bN_p.
	setup_timer_0(RTCC_INTERNAL|RTCC_DIV_32);

	//R̓_ŎJE^.
	setup_timer_1(T1_INTERNAL | T1_DIV_BY_8);
	CCP1CON = CCP_COMPARE_RESET_TIMER;	//Timer1ݒ.
	T1Start = 0;	//Timer1Xgbv.
	CCP_1 = 25000;	//100msec.

	//荞݋.
	enable_interrupts(INT_RTCC);
	enable_interrupts(INT_RDA);
	enable_interrupts(INT_CCP1);
	enable_interrupts(GLOBAL);

	//Timer1X^[g.
	T1Start = 1;

	while(1){
		if(getc_buff() != 0){
			switch(rcv_buff){
			case '\n':
				//񂩃`FbN.
				if((bBuff[2] == ':') && (bBuff[5] == ':')){
					//\鎞XV.
					bPrintStr[0] = bBuff[0] - '0';
					bPrintStr[1] = bBuff[1] - '0';
					bPrintStr[3] = bBuff[3] - '0';
					bPrintStr[4] = bBuff[4] - '0';

					//X[o.
					putc(bBuff[0]);
					putc(bBuff[1]);
					putc(bBuff[2]);
					putc(bBuff[3]);
					putc(bBuff[4]);
					putc(bBuff[5]);
					putc(bBuff[6]);
					putc(bBuff[7]);
					putc('\r');
					putc('\n');
				}
				bBuff[2] = ' ';
				bBuff[5] = ' ';
				iIndex = 0;
				break;
			default:
				//̎M.
				bBuff[iIndex] = rcv_buff;
				iIndex++;

				if(iIndex >= RCV_DATA_MAX){	//fail safe.
					bBuff[2] = ' ';
					bBuff[5] = ' ';
					iIndex = 0;
				}
				break;
			}
		}
	}
}

